# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/media/renesas,ceu.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Renesas Capture Engine Unit (CEU) Bindings

maintainers:
  - Jacopo Mondi <jacopo+renesas@jmondi.org>
  - linux-renesas-soc@vger.kernel.org

description: |+
  The Capture Engine Unit is the image capture interface found in the Renesas SH
  Mobile, R-Mobile and RZ SoCs. The interface supports a single parallel input
  with data bus width of 8 or 16 bits.

properties:
  compatible:
    enum:
      - renesas,r7s72100-ceu
      - renesas,r8a7740-ceu

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  clocks:
    maxItems: 1

  power-domains:
    maxItems: 1

  port:
    type: object
    additionalProperties: false

    properties:
      endpoint:
        type: object
        additionalProperties: false

         # Properties described in
         # Documentation/devicetree/bindings/media/video-interfaces.txt
        properties:
          remote-endpoint: true
          hsync-active: true
          vsync-active: true
          field-even-active: false
          bus-width:
            enum: [8, 16]
            default: 8

        required:
          - remote-endpoint

    required:
      - endpoint

required:
  - compatible
  - reg
  - interrupts
  - clocks
  - power-domains
  - port

additionalProperties: false

examples:
  - |
    #include <dt-bindings/interrupt-controller/arm-gic.h>
    #include <dt-bindings/clock/r7s72100-clock.h>

    ceu: ceu@e8210000 {
        reg = <0xe8210000 0x209c>;
        compatible = "renesas,r7s72100-ceu";
        interrupts = <GIC_SPI 332 IRQ_TYPE_LEVEL_HIGH>;
        clocks = <&mstp6_clks R7S72100_CLK_CEU>;
        power-domains = <&cpg_clocks>;

        port {
            ceu_in: endpoint {
                remote-endpoint = <&ov7670_out>;
                hsync-active = <1>;
                vsync-active = <0>;
            };
        };
    };
